#include <sourcemod>
#include <sdktools>
#include <emitsoundany>
#pragma newdecls required

#define PLUGIN_VERSION "1.1.1"

public Plugin myinfo = 
{
	name = "[CS:GO] Player Explode",
	author = "TechKnow & Twilight Suzuka & Neoxx",
	description = "Player explodes on death",
	version = PLUGIN_VERSION,
	url = "https://forums.alliedmods.net/showthread.php?p=2322856"
};

Handle Cvar_ExplodeEnable = INVALID_HANDLE;

int orange;
int g_HaloSprite;
int g_ExplosionSprite;

public void OnPluginStart()
{
        CreateConVar("sm_playerexplode_version", PLUGIN_VERSION, "Player Explode Version", FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	Cvar_ExplodeEnable = CreateConVar("explode_on", "1", "1 explosions on 0 is off", FCVAR_REPLICATED|FCVAR_NOTIFY);
	HookEventEx("player_death", Explode, EventHookMode_Pre);	
}

public void OnMapStart()
{
	orange = PrecacheModel("sprites/fire2.vmt");
	AddFileToDownloadsTable("materials/sprites/fire2.vtf");
	AddFileToDownloadsTable("materials/sprites/fire2.vmt");
	g_HaloSprite = PrecacheModel("sprites/halo2.vmt");
	AddFileToDownloadsTable("materials/sprites/halo2.vtf");
	AddFileToDownloadsTable("materials/sprites/halo2.vmt");
	g_ExplosionSprite = PrecacheModel("sprites/sprite_fire2.vmt");
	AddFileToDownloadsTable("materials/sprites/sprite_fire2.vtf");
	AddFileToDownloadsTable("materials/sprites/sprite_fire2.vmt");
	PrecacheSoundAny("ambient/explosions/explode_8.mp3", true);
	AddFileToDownloadsTable("sound/ambient/explosions/explode_8.mp3");
}

public Action Explode(Event event, const char[] name, bool dontBroadcast)
{
    if (!GetConVarBool(Cvar_ExplodeEnable)) 
	{
		return Plugin_Continue;
	}
    int id = GetClientOfUserId(event.GetInt("userid"));
	
	if (IsClientInGame(id)) 
	{
		ExplodePlayer(id);
	}
	
	return Plugin_Continue;
}

stock void ExplodePlayer(int id)
{
	float location[3];
	GetClientAbsOrigin(id, location);
			
	Explode1(location);
	Explode2(location);
}

public void Explode1(float vec1[3])
{
	int color[4]={188,220,255,200};
	Boom("ambient/explosions/explode_8.mp3", vec1);
	TE_SetupExplosion(vec1, g_ExplosionSprite, 10.0, 1, 0, 600, 5000);
	TE_SendToAll();
	TE_SetupBeamRingPoint(vec1, 10.0, 500.0, orange, g_HaloSprite, 0, 10, 0.6, 10.0, 0.5, color, 10, 0);
  	TE_SendToAll();
}

public void Explode2(float vec1[3])
{
	vec1[2] += 10;
	Boom("ambient/explosions/explode_8.mp3", vec1);
	TE_SetupExplosion(vec1, g_ExplosionSprite, 10.0, 1, 0, 600, 5000);
	TE_SendToAll();
}

public void Boom(const char[] sound, const float orig[3])
{
	EmitSoundToAllAny(sound,SOUND_FROM_WORLD,SNDCHAN_AUTO,SNDLEVEL_NORMAL,SND_NOFLAGS,SNDVOL_NORMAL,SNDPITCH_NORMAL,-1,orig,NULL_VECTOR,true,0.0);
}